from django.shortcuts import render, redirect
from .models import *
from users.models import Membre

# Create your views here.

def index(request):
    featured_news = News.objects.all().order_by('-published_date')[:3]
    postlist = Post.objects.all().order_by('-datetime')
    testimony = Testimonial.objects.all().order_by('-date')
    partner = Partner.objects.all().order_by('?')
    if request.method == 'POST':
        form = SubscriptionForm(request.POST)
        if form.is_valid():
            email = form.cleaned_data['email']
            subscriber, created = Subscriber.objects.get_or_create(email=email)
            if created:
                messages.success(request, 'Vous vous êtes abonné avec succès.')
            else:
                messages.info(request, 'Vous êtes déjà abonné.')
            return redirect('home')

    else:
        form = SubscriptionForm()

    context ={
        'postlist':postlist,
        'partner':partner,
        'testimony':testimony,
        'featured_news':featured_news,
        'form':form,
    }

    return render(request, "core/index.html", context)

def about(request):
    photos = Album.objects.all().order_by('?')[0:3]
    member = Membre.objects.all().order_by('position')
    if request.method == 'POST':
        form = SubscriptionForm(request.POST)
        if form.is_valid():
            email = form.cleaned_data['email']
            subscriber, created = Subscriber.objects.get_or_create(email=email)
            if created:
                messages.success(request, 'Vous vous êtes abonné avec succès.')
            else:
                messages.info(request, 'Vous êtes déjà abonné.')
            return redirect('home')

    else:
        form = SubscriptionForm()
        
    context = {
        'photos':photos,
        'member': member,
        'form':form,

    }
    return render(request, 'core/about.html', context)

def album(request):
    photos = Album.objects.all().order_by('?')[0:12]
    context = {
        'photos':photos,
    }
    return render(request, 'core/album.html', context)

def contact(request):

    context = {

    }
    return render(request, 'core/contact.html', context)

from django.contrib import messages
from .forms import SubscriptionForm
from .models import Subscriber

#def unsubscribe(request):
    #if request.method == 'POST':
        #email = request.POST.get('email')
        #try:
            #subscriber = Subscriber.objects.get(email=email)
            #subscriber.delete()
            #messages.success(request, 'You have unsubscribed successfully.')
        #except Subscriber.DoesNotExist:
            #messages.error(request, 'Email address not found.')
    #return render(request, 'unsubscribe.html'
# )

def send_newsletter(request):
    # Logic to send newsletters
    subscribers = Subscriber.objects.filter(subscribed=True)
    # Send newsletters to subscribers
    return render(request, 'core/index.html')