from django.db import models
from django.contrib.auth.models import User
from django_resized import ResizedImageField
import random
# Create your models here.

class Membre(models.Model):
    nom = models.CharField(max_length=250)
    postNom = models.CharField(max_length= 200,)
    prenom = models.CharField(max_length= 200,)
    service = models.CharField(max_length= 200,)
    fonction = models.CharField(max_length= 200,)
    phone = models.CharField(max_length= 200,)
    email = models.CharField(max_length= 200,)
    Joined_date = models.CharField(max_length= 200,)
    position = models.IntegerField(null=True,)
    sid = models.IntegerField(blank=True, null=True,  unique=True)
    image = ResizedImageField(size=[250, 250], upload_to='membres/', blank=True, null=True, default='./images/user-default.png')

    @property
    def imageURL(self):
        try:
            url = self.image.url
        except:
            url = ''
        print('URL', url)
        return url

    def save(self, *args, **kwargs):
        if not self.sid:
            # Generate a random number between 1 and 100
            self.sid = random.randint(1, 100)
        super(Membre, self).save(*args, **kwargs)

    def __str__(self):
        return self.prenom + " " + self.nom + " " + self.fonction
        
class ContactMessage(models.Model):
    name = models.CharField(max_length=100)
    number = models.CharField(max_length=100)
    email = models.EmailField(max_length=100)
    message = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.name
        
class Sponsor(models.Model):
    title = models.CharField(max_length=200)
    website = models.CharField(max_length=200,null=True)
    datetime = models.DateTimeField(auto_now_add=True)
    image = ResizedImageField(size=[300, 100], upload_to='sponsor/', blank=True, null=True)

    @property
    def imageURL(self):
        try:
            url = self.image.url
        except:
            url = ''
        print('URL', url)
        return url

    def __str__(self):
        return self.title